#include <Application.h>
#include <InterfaceKit.h>
#include <StorageKit.h>
#include <TrackerAddOn.h>
#include <ctype.h>

void makeDirectoryLowercase(entry_ref *Reference);
void makeLowercase(entry_ref *Reference);

void makeLowercase(entry_ref *Reference)
{
	BEntry Entry;
	char Name[B_FILE_NAME_LENGTH];
	char *NamePtr = Name;
	if(Entry.SetTo(Reference) != B_NO_ERROR)
		return;
	if (Entry.GetName(Name) != B_NO_ERROR)
		return;
	while (*NamePtr) {
		*NamePtr = tolower(*NamePtr);
		NamePtr++;
	}

	Entry.Rename(Name);
}

void makeDirectoryLowercase(entry_ref *Reference)
{
	BDirectory Directory;
	if(Directory.SetTo(Reference) != B_OK)
		return;
	BFile SubFile;
	BDirectory SubDirectory;
	entry_ref Refs;
	while(Directory.GetNextRef(&Refs) != B_ENTRY_NOT_FOUND)
	{
		if(SubDirectory.SetTo(&Refs) == B_NO_ERROR)
			makeDirectoryLowercase(&Refs);
		else
			if(SubFile.SetTo(&Refs,B_READ_ONLY) == B_NO_ERROR)
				makeLowercase(&Refs);
	}
	makeLowercase(Reference);
}

void process_refs(entry_ref Reference, BMessage *msg, void *)
{
	uint32 type;
	int32 count;
	BFile File;
	BDirectory Directory;
	msg->GetInfo("refs", &type, &count);
	if (count == 0)
	{
		(new BAlert("","Please select a file or folder", "Later Dude!"))->Go();
		return;
	}
	for (long i = 0; i < count; i++)
	{
		msg->FindRef("refs",i,&Reference);
		if(Directory.SetTo(&Reference) == B_OK)
			makeDirectoryLowercase(&Reference);
		else
			makeLowercase(&Reference);
	}
}
